Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 156238 - ocaml - FC4 rebuild failed
Summary: ocaml - FC4 rebuild failed
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: ocaml
Version: rawhide
Hardware: i386
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Gérard Milmeister
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE4Target
TreeView+ depends on / blocked
 
Reported: 2005-04-28 13:18 UTC by Michael Schwendt
Modified: 2007-11-30 22:11 UTC (History)
0 users

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2005-05-26 11:23:01 UTC


Attachments (Terms of Use)
Workaround gcc asm constraints bug (deleted)
2005-05-10 19:18 UTC, Toshio Kuratomi
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
GNU Compiler Collection 21291 None None None Never

Description Michael Schwendt 2005-04-28 13:18:24 UTC
This package failed to rebuild for FC4 Development around 2005-04-11 after an
automated release bump.

Build failure logs at: http://fedoraproject.org/extras/development/build-logs/

Comment 1 Toshio Kuratomi 2005-05-09 18:44:21 UTC
gcc bug.  Posted:
http://gcc.gnu.org/bugzilla/show_bug.cgi?id=21291

Looking into the workaround posted there.

Comment 2 Toshio Kuratomi 2005-05-10 19:18:43 UTC
Created attachment 114218 [details]
Workaround gcc asm constraints bug

This seems to work.  Compiled in development mach and tested that it produces
correct output when used with a simple big number application.	(Changed the
example in the README from factorial to a sumnorial/"subnorial" and ran it.)

Comment 3 Toshio Kuratomi 2005-05-10 19:25:47 UTC
Proceedure:
1) Figured out that gcc-3.4 was able to generate proper assembly for this but
gcc-4 was not.
2) Found that gcc-4.0 is apparently not properly trying to use memory where it
can when it runs out of registers.
3) Examined the gcc-3.4 code for the variables it assigned to memory rather than
registers.
4) Began changing the constraints for those variables from reg-or-memory to
memory until we had enough free registers to compile the asm template.

Comment 4 Toshio Kuratomi 2005-05-23 01:20:22 UTC
With this patch and the one referenced in Bug #154708 ocaml compiles, and runs.
 It compiles lablgtk and unison without with some minor work done to update
lablgtk (and no work done on unison.)  unison is running without issues thus far
on both i386 and x86_64.

I'm going to go ahead and commit changes and request a build.

Comment 5 Toshio Kuratomi 2005-05-26 11:02:49 UTC
Ocaml 3.08-5 has been built.  I'm going to go work on the lablgtk bug and then
kick off a unison build.  This bug can most likely be closed and if there are
issues with ocaml, a new bug opened.

Comment 6 Toshio Kuratomi 2005-05-26 11:07:36 UTC
FYI:  I didn't submit this patch upstream as it seemed to be due to a gcc4 bug.
 They may be interested in it anyway (The referenced gcc4 bug is about compiling
ocaml).  Go ahead and contact upstream if you feel they'd be interested.

Comment 7 Michael Schwendt 2005-05-26 11:23:01 UTC
Yes, primary focus is on making the packages build for FC4. If it appears to
fail at run-time somewhere later, that would be a new bug.


Note You need to log in before you can comment on or make changes to this bug.